#!/opt/misc/bin/perl
# H+
#       Title   : hkcheck.pl
#       Author  : Daniel Blackman
#       Date    : 11/07/99
#       Synopsis: Verify state of housekeeping variables as measured 11/07/99
#       Keywords: GALEX, Regression Test
#       Revisions:
#       mm/dd/yy        name     comment
#       11/07/99  dbb  This is the first version of the regression test
#                      that was built to verify the GALEX A/B configuration.
# The sample values accepted as normal were developed overf several days.
#  Sometimes a whole set of hkp items wil suddenly assume new values close to,
# but systematically different from the previous values.  As this test develops,
# some of these changes are assumed normal and diagnostic reports are suppressed
# H-
# U+
#       Usage   : hkcheck 
#       Input   : none          
#       Output  : Reports samples that are out of expected range of values
# U-
#
# ****************************************************************************

#
$sample = hex(`hkprint cnt_timer`);
if ($sample == (0)) {
  print "cnt_timer stuck at zero!\n";
} else {
  print "cnt_timer  ", $sample, "\n";
}
$sample = hex(`hkprint cnt_pkt`);
if ($sample == (0)) {
  print ".";
} else {
  print "cnt_pkt ", $sample, "\n";
}
$sample = hex(`hkprint cnt_deca`);
if ($sample == (0)) {
  print ".";
} else {
  print "cnt_deca ", $sample, "\n";
}
$sample = hex(`hkprint cnt_decb`);
if ($sample == (0x00ffffff)) {
  print ".";
} else {
  print "cnt_decb ", $sample, "\n";
}
$sample = hex(`hkprint cnt_feca`);
if ($sample == (0)) {
  print ".";
} else {
  print "cnt_feca ", $sample, "\n";
}
$sample = hex(`hkprint cnt_fecb`);
if ($sample == (0xffffff)) {
  print ".";
} else {
  print "cnt_fecb ", $sample, "\n";
}
$sample = hex(`hkprint dce_diag0`);
if ($sample == (0x1b)) {
  print ".";
} else {
  print "dce_diag0 ", $sample, "\n";
}
$sample = hex(`hkprint dce_diag1`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_diag1 ", $sample, "\n";
}
$sample = hex(`hkprint dce_diag2`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_diag2 ", $sample, "\n";
}
$sample = hex(`hkprint dce_diag3`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_diag3 ", $sample, "\n";
}
$sample = hex(`hkprint dce_diag4`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_diag4 ", $sample, "\n";
}
$sample = hex(`hkprint dce_swver`);
if ($sample == (0x414e)) {
  print ".";
} else {
  print "dce_swver ", $sample, "\n";
}
printf "DCE S/W Version %d\n", $sample;

$sample = hex(`hkprint dce_lastcrc`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_lastcrc ", $sample, "\n";
}
$sample = hex(`hkprint dce_cmd_recv`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_cmd_recv ", $sample, "\n";
}
$sample = hex(`hkprint dce_cmd_exec`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_cmd_exec ", $sample, "\n";
}
$sample = hex(`hkprint dce_peek`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_peek ", $sample, "\n";
}
$sample = hex(`hkprint dce_mon0`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_mon0 ", $sample, "\n";
}
$sample = hex(`hkprint dce_mon1`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_mon1 ", $sample, "\n";
}
$sample = hex(`hkprint dce_mon2`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_mon2 ", $sample, "\n";
}
$sample = hex(`hkprint dce_mon3`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_mon3 ", $sample, "\n";
}
$sample = hex(`hkprint dce_mon4`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_mon4 ", $sample, "\n";
}
$sample = hex(`hkprint dce_mon5`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_mon5 ", $sample, "\n";
}
$sample = hex(`hkprint dce_mon6`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_mon6 ", $sample, "\n";
}
$sample = hex(`hkprint dce_mon7`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_mon7 ", $sample, "\n";
}
$sample = hex(`hkprint dce_addr0`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_addr0 ", $sample, "\n";
}
$sample = hex(`hkprint dce_addr1`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_addr1 ", $sample, "\n";
}
$sample = hex(`hkprint dce_addr2`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_addr2 ", $sample, "\n";
}
$sample = hex(`hkprint dce_addr3`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_addr3 ", $sample, "\n";
}
$sample = hex(`hkprint dce_addr4`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_addr4 ", $sample, "\n";
}
$sample = hex(`hkprint dce_addr5`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_addr5 ", $sample, "\n";
}
$sample = hex(`hkprint dce_addr6`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_addr6 ", $sample, "\n";
}
$sample = hex(`hkprint dce_addr7`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_addr7 ", $sample, "\n";
}
$sample = hex(`hkprint dce_err`);
if ($sample == (0)) {
  print ".";
} else {
  print "dce_err ", $sample, "\n";
}
$sample = hex(`hkprint dig_shifta`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_shifta ", $sample, "\n";
}
$sample = hex(`hkprint dig_shiftb`);
if ( ($sample == (0x13)) | ($sample == (0x14)) | ($sample == (0x15)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_shiftb ", $sample, "\n";
}
$sample = hex(`hkprint dig_stretcha`);
if ( ($sample == (0x10)) | ($sample == (0x11)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_stretcha ", $sample, "\n";
}
$sample = hex(`hkprint dig_stretchb`);
if ( ($sample == (0x14)) | ($sample == (0x15)) | ($sample == (0x16)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_stretchb ", $sample, "\n";
}
$sample = hex(`hkprint dig_upperqa`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_upperqa ", $sample, "\n";
}
$sample = hex(`hkprint dig_upperqb`);
if ( ($sample == (0x13)) | ($sample == (0x14)) | ($sample == (0x15)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_upperqb ", $sample, "\n";
}
$sample = hex(`hkprint dig_lowerqa`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_lowerqa ", $sample, "\n";
}
$sample = hex(`hkprint dig_lowerqb`);
if ( ($sample == (0x13)) | ($sample == (0x14)) | ($sample == (0x15)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_lowerqb ", $sample, "\n";
}
$sample = hex(`hkprint dig_begwalka`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_begwalka ", $sample, "\n";
}
$sample = hex(`hkprint dig_begwalkb`);
if ( ($sample == (0x13)) | ($sample == (0x14)) | ($sample == (0x15)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_begwalkb ", $sample, "\n";
}
$sample = hex(`hkprint dig_endwalka`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_endwalka ", $sample, "\n";
}
$sample = hex(`hkprint dig_endwalkb`);
if ( ($sample == (0x13)) | ($sample == (0x14)) | ($sample == (0x15)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_endwalkb ", $sample, "\n";
}
$sample = hex(`hkprint dig_timeta`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_timeta ", $sample, "\n";
}
$sample = hex(`hkprint dig_timetb`);
if ( ($sample == (0x13)) | ($sample == (0x14)) | ($sample == (0x15)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_timetb ", $sample, "\n";
}
$sample = hex(`hkprint dig_refa`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_refa ", $sample, "\n";
}
$sample = hex(`hkprint dig_refb`);
if ( ($sample == (0x13)) | ($sample == (0x14)) | ($sample == (0x15)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "dig_refb ", $sample, "\n";
}
$sample = hex(`hkprint hv_fstat`);
if ( ($sample == (0x84)) | ($sample == (0x85)) | ($sample == (0x86)) | ($sample == (0x87)) | ($sample == (0x88)) ) {
  print ".";
} elsif (($sample == 0x0)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "hv_fstat ", $sample, "\n";
}
$sample = hex(`hkprint hv_currmona`);
if ($sample == (0x0b)) {
  print ".";
} elsif ($sample == 0x08) {
  print ",";
} elsif (($sample == 0x0)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "hv_currmona ", $sample, "\n";
}
$sample = hex(`hkprint hv_currmonb`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "hv_currmonb ", $sample, "\n";
}
$sample = hex(`hkprint hv_voltmona`);
if ( ($sample == (0x0c)) | ($sample == (0x0b))) {
  print ".";
} elsif ( ($sample == (0x08))  | ($sample == (0x09)) ) {
  print ",";
} elsif (($sample == 0x0)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "hv_voltmona ", $sample, "\n";
}
$sample = hex(`hkprint hv_voltmonb`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "hv_voltmonb ", $sample, "\n";
}
$sample = hex(`hkprint hv_vgrida`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "hv_vgrida ", $sample, "\n";
}
$sample = hex(`hkprint hv_vgridb`);
if (($sample == (0x6a)) | ($sample == (0x69))) {
  print ".";
} elsif (($sample == 0x6C) || ($sample == 0x6D)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "hv_vgridb ", $sample, "\n";
}
$sample = hex(`hkprint hv_vdaca`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "hv_vdaca ", $sample, "\n";
}
$sample = hex(`hkprint hv_vdacb`);
if ( ($sample == (0x10)) | ($sample == (0x12)) | ($sample == (0x13)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "hv_vdacb ", $sample, "\n";
}
$sample = hex(`hkprint hv_currlim`);
if ($sample == (0x80)) {
  print ".";
} else {
  print "hv_currlim ", $sample, "\n";
}
$sample = hex(`hkprint hv_loa`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "hv_loa ", $sample, "\n";
}
$sample = hex(`hkprint hv_lob`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "hv_lob ", $sample, "\n";
}
$sample = hex(`hkprint hv_noma`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "hv_noma ", $sample, "\n";
}
$sample = hex(`hkprint hv_nomb`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "hv_nomb ", $sample, "\n";
}
$sample = hex(`hkprint hv_maxa`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "hv_maxa ", $sample, "\n";
}
$sample = hex(`hkprint hv_maxb`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "hv_maxb ", $sample, "\n";
}
$sample = hex(`hkprint hv_rampt`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "hv_rampt ", $sample, "\n";
}
$sample = hex(`hkprint mem_ram`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "mem_ram ", $sample, "\n";
}
$sample = hex(`hkprint mem_rom`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "mem_rom ", $sample, "\n";
}
$sample = hex(`hkprint mem_xfer`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "mem_xfer ", $sample, "\n";
}
$sample = hex(`hkprint mem_u7`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "mem_u7 ", $sample, "\n";
}
$sample = hex(`hkprint mem_u2`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "mem_u2 ", $sample, "\n";
}
$sample = hex(`hkprint mem_upper`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "mem_upper ", $sample, "\n";
}
$sample = hex(`hkprint mem_lower`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "mem_lower ", $sample, "\n";
}
$sample = hex(`hkprint crp_cnta`);
if ($sample == (0x1000)) {
  print ".";
} else {
  print "crp_cnta ", $sample, "\n";
}
$sample = hex(`hkprint crp_cntb`);
if ($sample == (0x1000)) {
  print ".";
} else {
  print "crp_cntb ", $sample, "\n";
}
$sample = hex(`hkprint crp_inta`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "crp_inta ", $sample, "\n";
}
$sample = hex(`hkprint crp_intb`);
if ($sample == (0x0)) {
  print ".";
} else {
  print "crp_intb ", $sample, "\n";
}
$sample = hex(`hkprint aux_ilim`);
if ($sample == (0x2a)) {
  print ".";
} else {
  print "aux_ilim ", $sample, "\n";
}
$sample = hex(`hkprint aux_pos`);
if ( ($sample == (0x13)) | ($sample == (0x16)) ) {
  print ".";
} elsif (($sample == 0x0)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "aux_pos ", $sample, "\n";
}
$sample = hex(`hkprint aux_actv`);
if ( ($sample == (0x15)) | ($sample == (0x17)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "aux_actv ", $sample, "\n";
}
$sample = hex(`hkprint aux_motr`);
if ( ($sample == (0x15)) | ($sample == (0x17)) | ($sample == (0x18)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} elsif ($sample == (0x15)) {
  print "aux_motr changed reference! expected 0x17 or 0x18. got 0x15\n"
} else {
  print "aux_motr ", $sample, "\n";
}
$sample = hex(`hkprint temp_dva_a`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_dva_a ", $sample, "\n";
}
$sample = hex(`hkprint temp_dva_b`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_dva_b ", $sample, "\n";
}
$sample = hex(`hkprint temp_act`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_act ", $sample, "\n";
}
$sample = hex(`hkprint temp_hvfm`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_hvfm ", $sample, "\n";
}
$sample = hex(`hkprint temp_hvps`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_hvps ", $sample, "\n";
}
$sample = hex(`hkprint temp_ip`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_ip ", $sample, "\n";
}
$sample = hex(`hkprint temp_lvps`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_lvps ", $sample, "\n";
}
$sample = hex(`hkprint temp_ampa`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_ampa ", $sample, "\n";
}
$sample = hex(`hkprint temp_ampb`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_ampb ", $sample, "\n";
}
$sample = hex(`hkprint temp_tdca`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_tdca ", $sample, "\n";
}
$sample = hex(`hkprint temp_tdcb`);
if ($sample == (0xff)) {
  print ".";
} else {
  print "temp_tdcb ", $sample, "\n";
}
$sample = hex(`hkprint temp_dce`);
if ( ($sample == (0x99)) | ($sample == (0x9d)) | ($sample == (0x9c)) | ($sample == (0x9b)) | ($sample == (0x9a)) ) {
  print ".";
} elsif (($sample == 0x95) || ($sample == 0x96)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "temp_dce ", $sample, "\n";
}
$sample = hex(`hkprint volt_p5d`);
if( ($sample == (0x0cf)) | ($sample == (0x0d0)) ) {
  print ".";
} else {
  print "volt_p5d ", $sample, "\n";
}
$sample = hex(`hkprint volt_p15d`);
if ( ($sample == (0x08)) | ($sample == (0x0b)) ) {
  print ".";
} elsif (($sample == 0x0)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "volt_p15d ", $sample, "\n";
}
$sample = hex(`hkprint volt_m15d`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "volt_m15d ", $sample, "\n";
}
$sample = hex(`hkprint powr_pmon`);
if ( ($sample == (0x14)) | ($sample == (0x17)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "powr_pmon ", $sample, "\n";
}
$sample = hex(`hkprint volt_p15ta`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "volt_p15ta ", $sample, "\n";
}
$sample = hex(`hkprint volt_p15tb`);
if ( ($sample == (0x13)) | ($sample == (0x14)) | ($sample == (0x15)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "volt_p15tb ", $sample, "\n";
}
$sample = hex(`hkprint volt_p5ta`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "volt_p5ta ", $sample, "\n";
}
$sample = hex(`hkprint volt_p5tb`);
if ( ($sample == (0x13)) | ($sample == (0x14)) | ($sample == (0x15)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "volt_p5tb ", $sample, "\n";
}
$sample = hex(`hkprint volt_m15ta`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "volt_m15ta ", $sample, "\n";
}
$sample = hex(`hkprint volt_m15tb`);
if ( ($sample == (0x13)) | ($sample == (0x15)) | ($sample == (0x14)) ) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "volt_m15tb ", $sample, "\n";
}
$sample = hex(`hkprint volt_m5ta`);
if ( ($sample == (0x10)) | ($sample == (0x11)) | ($sample == (0x12)) ) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print "volt_m5ta ", $sample, "\n";
}
$sample = hex(`hkprint volt_m5tb`);
if ( ($sample == (0x13)) | ($sample == (0x15)) | ($sample == (0x14))) {
  print ".";
} elsif (($sample == 0x07) || ($sample == 0x06) ) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print ("volt_m5tb ", $sample, "\n");
}

$sample = hex(`hkprint p21mon`);
if ( ($sample == (0x10))) {
  print ".";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print ("p21mon ", $sample, "\n");
}

$sample = hex(`hkprint m15mon`);
if ( ($sample == (0x10))) {
  print ".\n";
} elsif (($sample == 0x03)) {
  #  case of DIB B,A; no power supply
  print "-";
} else {
  print ("m15mon ", $sample, "\n");
}

#	Execute the command
#system($cmd);
