#!/opt/misc/bin/perl
                                   $hkssubs::version = "hks v1.006 10 Apr 00";
#-----------------------------------------------------------------------------
#
#                    SSSSS
#  H    H   K    K  S     S   U    U   BBBBB     SSSS
#  H    H   K   K   S         U    U   B    B   S
#  HHHHHH   KKKK     SSSSS    U    U   BBBBB     SSSS
#  H    H   K  K          S   U    U   B    B        S
#  H    H   K   K   S     S   U    U   B    B   S    S
#  H    H   K    K   SSSSS     UUUU    BBBBB     SSSS
#
#-----------------------------------------------------------------------------
# 1.003 28 Mar 00 dbb Since v16819 & v16817 are currently installed in G/C,
#                     hks must be sure to upload to upper only after a
#                     partial version has move the rx/tx buffers.
#                     This hks does some smart uploading...
# 1.005  7 Apr 00 dbb Added HV tests, Reset Tests, Verbose switch
# 1.006 10 Apr 00 dbb Fixed a bug in cmd that caused diag 6 due to incorrect
#                     use of hex function on bareword 0xffff, which is already
#                     treated as a word value...
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# The 'use strict' direrctive forces the coder to follow rules that might keep
# him out of trouble by calling attention to undeclared variables and the like.
use strict;

sub UpdateFromSharedMemory { # UpdateFromSharedMemory; # fetch housekeeping data, do any monitoring...
  %main::memitems = split(" ",`hkprint 0x1040-183e`); # a snapshot of hkp memory
  # if (!defined $hksubs::lctr) { $hksubs::lctr = 0; }
  # print '<'; printf "%d", $hksubs::lctr++; print '>';
} # sub UpdateFromSharedMemory

#-----------------------------------------------------------------------------
  sub checkactivity {
    my @hsamples = split(" ", `hkprint 0x1680`);   # get result from  hkprint
    my $lasttimer = hex($hsamples[-1]);            # fetch the cnt_timer
    my $sample = hex($hsamples[-1]);               # get value from housekeeping
    my $timeout = 50; # best guess
    while (($lasttimer == $sample) && ($timeout)) {
      system("noop");
      system("sleep 1");
      @hsamples = split(" ", `hkprint 0x1680`);   # get result from  hkprint
      $sample = hex($hsamples[-1]);                # get value from housekeeping
      $timeout--;                              # countdown
    } # while
    UpdateFromSharedMemory; # fetch housekeeping data, do any monitoring...
    # my $diff = hex($main::memitems{"0x183e"}) - hex($main::memitems{"0x1440"});
    # print "Diff: $diff";
  # if ($diff);
    if (!$timeout) { print "Last $lasttimer == $sample\n"; }
    return $timeout;
  } # checkactivity
#-----------------------------------------------------------------------------
sub currentversion {
  UpdateFromSharedMemory; # fetch housekeeping data, do any monitoring...
  my $eversion = hex($main::memitems{"0x16fe"});      # get version from housekeeping
  my $timeout = $main::stdtimeout; # best guess
  while ((!$eversion) && ($timeout)) {
    print "Asking for a hkp update...\n";
    system("noop");
    if (defined $main::Slow) { system("sleep 1"); }
    %main::hkpitems = split(" ",`hkprint 0x1440-183e`); # take a snapshot hkp memory
    UpdateFromSharedMemory; # fetch housekeeping data, do any monitoring... (updates main::memitems)
    $eversion = hex($main::memitems{"0x16fe"});      # get version from housekeeping
    $timeout--;
  }
  return $eversion;
} # sub currentversion 

#-----------------------------------------------------------------------------
sub decodebits {
  #print " CRC-Upper $main::memitems{'0x177e'}";
  print "CRC-Lower $main::memitems{'0x16fa'}";
  print " CRC-ROM $main::memitems{'0x16fc'}";

  if ($main::project eq "COS") {
    my $auxpwron = (hex($main::memitems{"0x172c"}) & 0x0100) == 0x0100;
    if ($auxpwron) { print " AUX " ; }
  } # if

  my $pmask = ($main::project eq "COS")?0xC0:0x84; # select the right mask bits
  my $promson = (hex($main::memitems{"0x172c"}) & $pmask) == $pmask;
  if ($promson) { print " PROMS " ; }

  my $codespace = (hex($main::memitems{"0x16e4"}) & 0x0200) == 0x0200;
  if ($codespace) { print " UPPER " ; }

  my $controls = hex($main::memitems{"0x172a"}); # lets looks at controls bits
  print " LA" if ($controls & 0x0001);
  print " OP " if ($controls & 0x0002);
  print " CL " if ($controls & 0x0004);
  print " HVPWR " if ($controls & 0x0008);
  print " HVENA1 " if ($controls & 0x0010);
  print " HVQPWR " if ($controls & 0x0020);
  print " HPLUG" if ($controls & 0x0040);
  print " DET0ID" if ($controls & 0x0080);
  if ($main::project eq "COS") {

  print " ACTEN" if ($controls & 0x0100);
  print " AXAN" if ($controls & 0x0200);
  print " MPWR/ACTEN" if ($controls & 0x0400);
  print " MPWR" if ($controls & 0x0800);
  print " AXPWR" if ($controls & 0x1000);
  print " HV0" if ($controls & 0x2000);
  print " RPLUG" if ($controls & 0x4000);
  print " DET1ID" if ($controls & 0x8000);

  $controls = hex($main::memitems{"0x172c"}); # lets looks at controls bits
  print " HV_ARM/ " if ($controls & 0x0001);
  print " V10ARM/ " if ($controls & 0x0002);
  print " PROM2/  " if ($controls & 0x0004);
  print " TDCX/DDIR " if ($controls & 0x0008);
  print " TDCY/DDIR " if ($controls & 0x0010);
  print " NUV/" if ($controls & 0x0020);
  print " FUV/PROM" if ($controls & 0x0040);
  print " PROM1/PROM2" if ($controls & 0x0080);
  print "  /AUXPena" if ($controls & 0x0100);
  print "  /Act1" if ($controls & 0x0200);
  print "  /Act2" if ($controls & 0x0400);
  print "  /V7NC" if ($controls & 0x0800);
  print "  /ActEn" if ($controls & 0x1000);
  print "  /V21NC" if ($controls & 0x2000);
  print "  /V22NC" if ($controls & 0x4000);
  print "  /Override" if ($controls & 0x8000);

  } # if main::project is COS
} # sub decodebits

#-----------------------------------------------------------------------------
sub cmd {
  #       Check for validity of the argument
  my $preopcode = (shift(@_));
  my $param1 = (shift(@_));
  my $param2 = (shift(@_));
  my $param3 = (shift(@_));

  if($preopcode < 0 || $preopcode > 65535) {
    printf "Invalid address: 0x%04x. The value must be between 0 and FFFF\n", $preopcode;
        exit;
  }

  if(($param1 < 0) || ($param1 > 65535)) {
    printf "Invalid param1: 0x%04x. The value must be between 0 and FFFF\n", $param1;
        exit;
  }

  if(($param2 < 0) || ($param2 > 65535)) {
    printf "Invalid param2: 0x%04x. The value must be between 0 and FFFF\n", $param2;
        exit;
  }

  if(($param3 < 0) || ($param3 > 65535)) {
    printf "Invalid param3: 0x%04x. The value must be between 0 and FFFF\n", $param3;
        exit;
  }

  #	Form the serial number
  my $ser = `getnextserial`;

  #	Form the bitwise inverse of the serial number
  my $iser = $ser ^ (0xffff);

  #	Form the address/value string for the serial number
  $ser = sprintf("0x0444%04x", $ser);

  #	Form the address/value string for the bitwise inverse of the 
  #	serial number
  $iser = sprintf("0x0446%04x", $iser);

  #	Form the bitwise inverse of the OpCode
  my $preiopcode = ($preopcode) ^ (0xFFFF);

  #	Form the address/value string for the opcode
  my $opcode = sprintf("0x0440%04x", $preopcode);

  #	Form the address/value string for the bitwise inverse of the opcode
  my $iopcode = sprintf("0x0442%04x", $preiopcode);

  #	Form parameter 0  from the first command line argument (the address to peek)
  my $par0 = ($param1);

  #	Form bitwise inverse of parameter 0
  my $ipar0 = $par0 ^ (0xFFFF);

  #	Form the address/value string for parameter 0
  $par0 = sprintf("0x0448%04x", $par0);

  #	Form the address/value string for parameter 0
  $ipar0 = sprintf("0x044A%04x", $ipar0);

  #	Form parameter 1 (dest address)
  my $par1 = $param2;

  #	Form bitwise inverse of parameter 1
  my $ipar1 = $par1 ^ (0xFFFF);

  #	Form the address/value string for parameter 1
  $par1 = sprintf("0x044C%04x", $par1);

  #	Form the address/value string for parameter 1
  $ipar1 = sprintf("0x044E%04x", $ipar1);

  #	Form parameter 2 (not used)
  my $par2 = $param3;

  #	Form bitwise inverse of parameter 2
  my $ipar2 = $par2 ^ (0xFFFF);

  #	Form the address/value string for parameter 2
  $par2 = sprintf("0x0450%04x", $par2);

  #	Form the address/value string for parameter 2
  $ipar2 = sprintf("0x0452%04x", $ipar2);

  #	Form the command string
  my $cmd = sprintf("cmd_client %s %s %s %s %s %s %s %s %s %s > /dev/null",
   $ipar2, $par2, $ipar1, $par1, $ipar0, $par0, $iser, $ser, $iopcode, $opcode);

  #	Execute the command
  if (defined $main::Verbose) { # trying out use of verbose level
  if ($main::Verbose > 16384) { # trying out use of verbose level
    printf "\n::: %x %x %x %x :::", $preopcode, $param1, $param2, $param3;
    print " Sending $cmd\n";
  } # if verbose
  } # if verbose
  system($cmd);
} # sub cmd

#-----------------------------------------------------------------------------
sub gettimer {
  my @hsamples = split(" ", `hkprint cnt_timer`); # get result from  hkprint
  my $TimeStamp = hex($hsamples[-1]);
  return $TimeStamp;
} # gettimer

#-----------------------------------------------------------------------------
sub sendcommand {  # send a command and verify the response
  my $opcode = (shift(@_));
  my $param0 = (shift(@_));
  my $param1 = (shift(@_));
  my $param2 = (shift(@_));
  my $TimeStamp = gettimer; # read whatever hkprint thinks it is right now.
  my $PktCnt = hex($main::memitems{"0x1700"}); # fetch packet counter
  my $timeout = 150;
  my $Waiting = 1; # true, set false when a response was heard.
  my $NewPkt;

  cmd($opcode,$param0,$param1,$param2); # send the command and parameters
  if (defined $main::Slow) { system("sleep 1"); } # once-per-second behavior requested
  while (($Waiting) && ($timeout)) {
    $Waiting = (gettimer == $TimeStamp); # read again, and look for change...
    $timeout--;
    if ((!($timeout % 5)) && ($Waiting)) {
      cmd(0xFFFF, 0, 0, 0);  # noop to push egse, if necessary
      if (defined $main::Slow) { system("sleep 1"); } # once-per-second behavior requested
    } # every few loops
    UpdateFromSharedMemory; # fetch housekeeping data, do any monitoring... (updates main::memitems)
    if (!$Waiting) {
      $NewPkt = hex($main::memitems{"0x1700"});
      $Waiting = ($NewPkt == $PktCnt); # we must wait for packet to be tallied
    } # if 
    # $diff = hex($main::memitems{"0x183e"}) - hex($memitems{"0x1440"});
    # print "Diff: $diff";
 # if ($diff);
  } # while waiting for a response or timeout
  # print ">>NewPkt:$NewPkt\n";
  return $timeout;
} # sub sendcommand

#-----------------------------------------------------------------------------
sub getcorrectcrc {
  sendcommand(0xffff,0,0,0); # hkpfull
  my @hsamples = split(" ", `hkprint 0x171c`);   # get result from  hkprint
  return hex($hsamples[-1]);               # get value from housekeeping
} # getcorrectcrc

#-----------------------------------------------------------------------------
sub getdiag0 {
  my @hsamples = split(" ", `hkprint 0x1708`); # get result from  hkprint
  my $Diag = (0x00FF & hex($hsamples[-1]));
  if ($Diag) {
    printf "DIAG:%02x", $Diag ;
    print " CRC-Lower $main::memitems{'0x16fa'}" if ($Diag == 0x18);
    print "\n";
  }     # get value from housekeeping
  return $Diag;     # get value from housekeeping
} # getdiag0

#-----------------------------------------------------------------------------
sub removediags {  # clear list so we can note updates
      #before we send the command, we want to be sure we are in the right state
      #so we send a noop to update housekeeping, then look at the latest diag.

  my $timeout = 15; # best guess

  if (defined $main::Verbose) { if ($main::Verbose > 1024) {
    print "Checking diagnostic stack for any old diagnostics... ";
  }} # if verbose
  my $LatestDiag = getdiag0;
  while (($LatestDiag) && ($timeout)) {
    if (defined $main::Verbose) { if ($main::Verbose > 1024) {
      print "Removing old diagnostics by sending a command ";
      print "to clear diagnostic stack. ($LatestDiag) ";
    }} # if verbose
    sendcommand(0xf4f4,0,0,0); # clrdiag
    if (defined $main::Verbose) { if ($main::Verbose > 1024) {
      print "Checking diagnostic stack for any new diagnostics... ";
    }} # if verbose
    $LatestDiag = getdiag0;
    $timeout--;
    if (!$timeout) { die "Timeout"; }
  }
  return $LatestDiag;
} # removediags

#-----------------------------------------------------------------------------
sub showversioninfo {
  my $eversion = currentversion;
  my $sample = hex($main::memitems{"0x16f4"});        # get statusbits1
  $main::project = ($sample & 0x10)?"GALEX":"COS";
  print "\nVersion $eversion ($main::project) ";
  my $wdstate = (hex($main::memitems{"0x16e4"}) & 0x4000) == 0x4000;
  if (!$wdstate) {
    printf "\tWatchDog is %sabled ", ($wdstate)?"En":"Dis";
    system("wdenable");
  } # if
  print "\n";
  my $ess_flag = (hex($main::memitems{"0x16e4"}) & 0x0020) == 0x0020;
  if ($ess_flag) {
    print "ESS\n";
    cmd 0xabab, 0x10, 0, 0;
    system("hkprint 0x16e4");
  }
} # sub showversioninfo 

#-----------------------------------------------------------------------------
sub loadhexfile {
  my $eversion = currentversion;
    # fixed using old method, pending improvement to algorithm below
  if ($eversion > 16855) {
    print "Resetting...\n";
    system("test2 ; sleep 1");
    system("noop ; sleep 1");
    %main::hkpitems = split(" ",`hkprint 0x1440-183e`); # take a snapshot hkp memory
    %main::memitems = split(" ",`hkprint 0x1040-183e`); # a snapshot of hkp memory
    removediags;
    print "\n";
    showversioninfo;
    $eversion = currentversion;
    if ($eversion > 16855) { die "Mofo!" ; }
  }
  print "Uploading $main::HexUploadFilename\n";
  system("sh $main::HexUploadFilename > /dev/null");
  removediags;
  sendcommand(0xf3f3,0,0,0); # jmpcode
  # sendcommand(0xffff,0,0,0); # hkpfull
  showversioninfo;
  return;

  my $result = open Hexfile, "<$main::HexUploadFilename";
  my $TimeStamp = gettimer; # for later comparison
  while (<Hexfile>) {
    my @bytes = split /([0123456789ABCDEF][0123456789ABCDEF])/ ;
    my $Address = 256 * hex($bytes[3]) + hex($bytes[5]);
    if ($Address > 0xC800) {
      my $Length = hex($bytes[1]);
      my $Buffer = 0x0040;
      my $CmdLine = "cmd_client ";
      my $idx;
      for ($idx = 9; $idx < ((2 * $Length) + 8); $idx += 4) {
        $CmdLine .= sprintf "0x%04X%04X ", 
           $Buffer, (hex($bytes[$idx])+(256*hex($bytes[$idx+2])));
        $Buffer += 2;
      } # for
      removediags; # clear list so we can note updates
      system("$CmdLine > /dev/null"); # send data part
      sendcommand(0xadad,$Address,$Length,0); # UPLOAD
      my $LatestDiag = getdiag0; # check result
      if ($LatestDiag) {
        removediags; # clear list so we can note updates
        system("$CmdLine > /dev/null"); # send the data part again
        my $CorrectCRC = getcorrectcrc;
        sendcommand(0xadad,$Address,$Length,$CorrectCRC); # UPLOAD, again
        $LatestDiag = getdiag0;
        printf "CmdUpload .$LatestDiag.\n";
        if ($LatestDiag) { die "Second try"; }
      } # if
      my $NowStamp = gettimer; # for comparison against earlier sample
      my $DeltaNow = $NowStamp - $TimeStamp;
      print "Delta: $DeltaNow ";
      $TimeStamp = $NowStamp; # for later comparison
    } # if
  }
} # loadhexfile

#-----------------------------------------------------------------------------
sub useversion {
  if (defined $main::HexUploadFilename) {
    loadhexfile;
  } # if
} # sub useversion

#-----------------------------------------------------------------------------
sub TestHeader {
  my $tmsg = shift(@_);
  print "     *************************     ";
  print "$tmsg";
  print "     *************************\n";
} # TestHeader 

#-----------------------------------------------------------------------------
